!
!coupled relaxation
!
!THIS NEEDS MORE WORK/THOUGHT TO PROPERLY SIMULATE RELAXATION
!
set out;steps_relax_infl0_10_act0_24_cavk0_10 on
assign NAME0=active0_
assign NAME1=cavity_
assign NAME2=fullheart_def_0010_active_00
assign NAME3=_cavk_
assign INCREM=0.0
assign ITERS=20
assign TOL=0.001
!
! set up cavity reference state at end systole for relaxation
fem update solution cavity_reference average 196 in 1 node lv_cavity_base_nodes region 2
fem update solution cavity_reference average 203 in 1 node 14,18 region 3
!
!loop through decreasing intracellular calcium conc and increasing cavity impedances
!to simulate relaxation.
!
assign MAT=0.4
!DO "CA"=23..0:-1
DO "CA"=23..5:-1
  assign MAT2=`MAT*1000` truncate
  IF MAT2 < 10
    assign MATNUM=0000000//MAT2
  ELSEIF MAT2 < 100
    assign MATNUM=000000//MAT2
  ELSEIF MAT2 < 1000
    assign MATNUM=00000//MAT2
  ELSEIF MAT2 < 10000
    assign MATNUM=0000//MAT2
  ELSEIF MAT2 < 100000
    assign MATNUM=000//MAT2
  ELSEIF MAT2 < 1000000
    assign MATNUM=00//MAT2
  ELSE
    assign MATNUM=0//MAT2
  ENDIF
  IF CA > 9
    assign CANUM=CA
  ELSE
    assign CANUM=0//CA
!
!   Update position of basal cavity nodes to allow for early filling
!
    fem update solution cavity_reference average 196 in 1 node lv_cavity_base_nodes region 2
    fem update solution cavity_reference average 203 in 1 node 14,18 region 3
  ENDIF
  list assign
  fem define active;r;NAME0//CANUM reg 1
  fem define material;r;NAME1//MATNUM reg 2
  fem define material;r;NAME1//MATNUM reg 3
  fem solve increment INCREM iter ITERS coupled error TOL
  fem define initial;w;NAME2//CANUM//NAME3//MATNUM reg 1,2,3
  IF MAT > 9
    assign MAT=10
  ELSEIF MAT > 3.9
    assign MAT=`MAT+1.0`
  ELSEIF MAT > 1.5
    assign MAT=`MAT+0.8`
  ELSE
    assign MAT=`MAT+0.3`
  ENDIF
ENDDO
deassign CA
deassign NAME1
deassign NAME2
deassign INCREM
deassign ITERS
deassign TOL
set out off
