!
!coupled isovolumic contraction
!
set out;steps_contract_infl0_10 on
assign NAME1=active0_
assign NAME2=fullheart_def_0010_active_00
assign INCREM=0.0
assign ITERS=20
assign TOL=0.001
!
!loop through increasing intracellular calcium concentrations
!to simulate isovolumic contraction
!
!!DO "CA"=1..30
DO "CA"=1..24
  IF CA < 10
    assign CANUM=0//CA
  ELSE
    assign CANUM=CA
  ENDIF
  list assign
  fem define active;r;NAME1//CANUM reg 1
  fem solve increment INCREM iter ITERS coupled error TOL
  fem define initial;w;NAME2//CANUM reg 1,2,3
ENDDO
deassign CA
deassign NAME1
deassign NAME2
deassign INCREM
deassign ITERS
deassign TOL
set out off
